/*
	TVTest vOC

	GV-RCKIT3g
*/


#include <windows.h>
#include <tchar.h>
#include <shlwapi.h>
#define TVTEST_PLUGIN_CLASS_IMPLEMENT
#include "TVTestPlugin.h"
#include "resource.h"

#pragma comment(lib,"shlwapi.lib")

// vOCNX
class ZapTest : public TVTest::CTVTestPlugin
{
	bool m_fInitialized;	// ς݂?
	UINT_PTR TimerId;		// ^C}[ID
	UINT TimerCount;

	bool InitializePlugin();

	static LRESULT CALLBACK EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData);
	static BOOL CALLBACK MessageCallback(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam,
										 LRESULT *pResult,void *pClientData);

	static LRESULT CALLBACK ZapTest::DlgZapTestConfigProc(HWND hDlgWnd, UINT msg, WPARAM wp, LPARAM lp);

public:
	ZapTest();
	virtual bool GetPluginInfo(TVTest::PluginInfo *pInfo);
	virtual bool Initialize();
	virtual bool Finalize();
};


ZapTest::ZapTest()
	: m_fInitialized(false)
{
}


bool ZapTest::GetPluginInfo(TVTest::PluginInfo *pInfo)
{
	// vOC̏Ԃ
	pInfo->Type           = TVTest::PLUGIN_TYPE_NORMAL;
	pInfo->Flags          = TVTest::PLUGIN_FLAG_HASSETTINGS;
	pInfo->pszPluginName  = L"ZapTest";
	pInfo->pszCopyright   = L"Shizma Aonuma";
	pInfo->pszDescription = L"5bɈ`lAbv{^܂B";
	return true;
}


bool ZapTest::Initialize()
{
	// 

	// CxgR[obN֐o^
	m_pApp->SetEventCallback(EventCallback,this);
	TimerCount = 10;

	return true;
}


// vOCLɂꂽ̏
bool ZapTest::InitializePlugin()
{
	if (!m_fInitialized) {
		// bZ[W̓o^
		TimerId=::SetTimer(m_pApp->GetAppWindow(), 5050, TimerCount * 1000, NULL);
		if (TimerId==0){
			::MessageBox(m_pApp->GetAppWindow(),
					 TEXT("^C}[̐Ɏs܂B"),NULL,
					 MB_OK);
			return false;
		}

		m_fInitialized=true;
	}

	// bZ[WR[obN֐o^
	m_pApp->SetWindowMessageCallback(MessageCallback,this);

	return true;
}


bool ZapTest::Finalize()
{
	// I

	return true;
}


// CxgR[obN֐
// CxgNƌĂ΂
LRESULT CALLBACK ZapTest::EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData)
{
	ZapTest *pThis=static_cast<ZapTest*>(pClientData);

	switch (Event) {
	case TVTest::EVENT_PLUGINENABLE:
		// vOC̗LԂω
		if (lParam1!=0) {
			if (!pThis->InitializePlugin()) {
				::MessageBox(pThis->m_pApp->GetAppWindow(),
							 TEXT("ŃG[܂B"),NULL,
							 MB_OK | MB_ICONEXCLAMATION);
				return FALSE;
			}
		} else {
			KillTimer(pThis->m_pApp->GetAppWindow(), pThis->TimerId);
			pThis->m_pApp->SetWindowMessageCallback(NULL);
			pThis->m_fInitialized=false;
		}
		return TRUE;

	case TVTest::EVENT_PLUGINSETTINGS:
		if(::DialogBoxParam(g_hinstDLL, MAKEINTRESOURCE(IDD_DIALOG1), reinterpret_cast<HWND>(lParam1),
			(DLGPROC)DlgZapTestConfigProc, reinterpret_cast<LPARAM>(pThis)) == IDOK)
		{
			KillTimer(pThis->m_pApp->GetAppWindow(), pThis->TimerId);
			pThis->TimerId=::SetTimer(pThis->m_pApp->GetAppWindow(), 5050, pThis->TimerCount * 1000, NULL);
		}
		return TRUE;
	}
	return 0;
}


// bZ[WR[obN֐
BOOL CALLBACK ZapTest::MessageCallback(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam,
											LRESULT *pResult,void *pClientData)
{
	ZapTest *pThis=static_cast<ZapTest*>(pClientData);

	if (uMsg==WM_TIMER && wParam==pThis->TimerId) {
		// `lɑ
		pThis->m_pApp->SetNextChannel(true);
		return TRUE;
	}
	return FALSE;
}



// vOCNX̃CX^X𐶐
TVTest::CTVTestPlugin *CreatePluginClass()
{
	return new ZapTest;
}

LRESULT CALLBACK ZapTest::DlgZapTestConfigProc(HWND hDlgWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	HWND hCtrl;
	WCHAR TC[32];

	switch (msg) {
	case WM_INITDIALOG:
		{
			ZapTest *pThis=reinterpret_cast<ZapTest*>(lp);
			::SetProp(hDlgWnd,TEXT("This"),pThis);
			wsprintf(TC, L"%d", pThis->TimerCount);
			hCtrl = GetDlgItem(hDlgWnd, IDC_EDIT1);
			SetWindowText(hCtrl, TC);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case IDOK:
			{
				ZapTest *pThis=static_cast<ZapTest*>(::GetProp(hDlgWnd,TEXT("This")));
				hCtrl = GetDlgItem(hDlgWnd, IDC_EDIT1);
				GetWindowText(hCtrl, TC, 31);
				pThis->TimerCount=_wtoi(TC);
			}
			EndDialog(hDlgWnd, IDOK);
			break;
		case IDCANCEL:
			EndDialog(hDlgWnd, IDCANCEL);
			break;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
} 